﻿using System;
using System.Text;
using HeuristicLab.Problems.Instances.TSPLIB;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace UnitTests
{
    
    
    /// <summary>
    ///This is a test class for TSPLIBInstanceProviderTest and is intended
    ///to contain all TSPLIBInstanceProviderTest Unit Tests
    ///</summary>
  [TestClass()]
  public class TSPLIBInstanceProviderTest {
    /// <summary>
    ///A test for GetInstance
    ///</summary>
    [TestMethod()]
    public void GetTSPLIBTSPInstanceTest() {
      TSPLIBTSPInstanceProvider target = new TSPLIBTSPInstanceProvider();
      StringBuilder erroneousInstances = new StringBuilder();
      int count = 0;
      foreach (var id in target.GetInstanceDescriptors()) {
        try {
          target.GetInstance(id);
        } catch (Exception ex) {
          erroneousInstances.AppendLine(id.Name + ": " + ex.Message);
        }
        count++;
      }
      Assert.IsTrue(count > 0, "No problem instances were found.");
      Assert.IsTrue(erroneousInstances.Length == 0, "Some instances could not be parsed: " + Environment.NewLine + erroneousInstances.ToString());
    }
  }
}
